<?php
if (!defined('MOODLE_INTERNAL')) {
    die('Direct access to this script is forbidden.');    ///  It must be included from a Moodle page
}

require_once ($CFG->dirroot.'/course/moodleform_mod.php');
require_once ($CFG->dirroot.'/mod/flashchat/functions_chat.php');
class mod_flashchat_mod_form extends moodleform_mod {

	function definition() {
		global $CFG;
		$mform = $this->_form;
		if(isset($this->current->add)){
			
		}else{
			$thisurl = 'modedit.php?update='.$this->current->update.'&return='.$this->current->return;
			$mform->addElement('html','<style>.flashchat_h3{text-align:center;} .flashchat_h3 a{ padding:3px 5px; border:1px solid #dedede; background:#eaeaea; }</style>
				<h3 class="flashchat_h3">
					<a '.(isset($_GET['type'])?'':'class="red"').' href="'.$thisurl.'">Chat Setting</a>  
					<a '.(isset($_GET['type'])?'class="red"':'').' href="'.$thisurl.'&type=adminpanel">Admin Panel</a>
				</h3>');
		
		}
		
		
		if(isset($_GET['type']) && $_GET['type'] == 'adminpanel'){			
			if(isset($this->current->extendserver) && $this->current->extendserver == 2){
				$mform->addElement('html','<p style="text-align:center;">Sorry! Admin Panel is not available in the Free Chat Hosting Edition. 123FlashChat Full Version starts at $20. 
					<br />Click the link below to have a live Admin Panel Demo for testing.</p>
					<p style="text-align:center;"><a href="http://www.123flashchat.com/admin-panel-free.html" target="_blank">Live Demo</a></p>');				
			}else{
				$chat_admin_url = $this->current->client_loc."admin_123flashchat.swf?init_host=".$this->current->server_host."&init_port=".
					$this->current->server_port;
				if($this->current->extendserver == 1){
					$chat_admin_url .= "&init_group=".$this->current->group_name;				
				}
				$mform->addElement('html','<p style="text-align:center;">
				<object classid="clsid:D27CDB6E-AE6D-11cf-96B8-444553540000" codebase="http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=6,0,19,0" width="80%" height="528">
					<param name=movie value="'.$chat_admin_url.'">
					<param name=quality value="high">
					<param name="menu" value="false">
					<embed src="'.$chat_admin_url.'" quality="high" menu="false" width="80%" height="528" type="application/x-shockwave-flash" pluginspace="http://www.macromedia.com/go/getflashplayer"></embed>
				</object>
			</p>');		
			}			
		}else{
			$this->current->valid = get_valid($this->current);
			//server mode start
			$mform->addElement('html','<script src="'.$CFG->wwwroot.'/mod/flashchat/123flashchat_setting.js"></script>');		
			
			$mform->addElement('header', 'basesetting', get_string('basesettings', 'flashchat'));
			
			$mform->addElement('radio', 'extendserver', get_string('hosting_mode', 'flashchat'), get_string('run_own', 'flashchat') ,0,array('onclick'=>"changeserver(0)"));
			$mform->addElement('static', '','','<p style="font-family: verdana,sans-serif;font-style: italic;">
						Please download and install 123FlashChat first: <a target="_blank" href="http://www.123flashchat.com/download.html"> http://www.123flashchat.com/download.html</a>,<br /> 
						and set Chat Client Location to: http://&lt;your chat server domain or ip&gt;:35555/ </p>');
			$mform->addElement('radio', 'extendserver', '', get_string('run_host', 'flashchat'),1,array('onclick'=>"changeserver(1)"));
			$mform->addElement('static', '','','<p style="font-family: verdana,sans-serif;font-style: italic;">
						<a target="_blank" href="http://www.123flashchat.com/host.html">For paid host</a>, 
						please set the Chat Client Location like this, for example: http://host71120.123flashchat.com/moodle/, <a target="_blank" href="http://www.123flashchat.com/host.html">Buy host</a><br />
						<a target="_blank" href="http://www.123flashchat.com/host/apply.php">For trial host</a>, 
						please setup Chat Client Location like this: http://trial.123flashchat.com/yourhostname<br />
						Just replace "yourhostname" to the real one when you applied, <a target="_blank" href="http://www.123flashchat.com/host/apply.php">Apply trial host</a>
					</p>');
			
			$mform->addElement('radio', 'extendserver', '', get_string('run_free', 'flashchat'),2,array('onclick'=>"changeserver(2)"));		
			$mform->addElement('static', '','','<p style="font-family: verdana,sans-serif;font-style: italic;">
						This chat server mode is for testing the basic functions, only 1 room supported, no video chat function, and you don\'t have the administrator of this chat room, 
						you may select the mode 1 or 2 to get the full function and full control of your chat room.
					</p>');
			$mform->setType('extendserver', PARAM_INT);
			//server mode end
			
			//show login chat start
			if(isset($this->current->extendserver) && $this->current->extendserver == 2){
				$mform->addElement('html','<div id="login_chat" style="display:none;" >');
			}else{
				$mform->addElement('html','<div id="login_chat" >');
			}
			$mform->addElement('static', '',get_string('integrationurl', 'flashchat'),'To integrate users for auto-login to chat, please open the Chat Admin Panel,
							then System Settings > Integration Panel, set authentication URL to:
							<span style="color:red;">'.$CFG->wwwroot.'/mod/flashchat/login_chat.php?username=%username%&password=%password%</span><br />
							Then restart your chat server : Server Management &gt; Restart &gt; click Restart Server');
			$mform->addElement('html','</div>');
			//show login chat end
			
			//show server type start
			if(isset($this->current->extendserver) && $this->current->extendserver != 0){
				$mform->addElement('html','<div id="servertype" style="display:none;" >');
			}else{
				$mform->addElement('html','<div id="servertype" >');
			}
			$mform->addElement('radio', 'servertype', get_string('chat_server_type', 'flashchat'), get_string('server_type_chat', 'flashchat'),0, array('id'=>'servertype0', 'onclick'=>'chooseservertype(0);'));
			$mform->addElement('radio', 'servertype', '', get_string('server_type_ppv', 'flashchat'),1, array('id'=>'servertype1', 'onclick'=>'chooseservertype(1);'));
			$mform->setType('servertype', PARAM_INT);			
			$mform->addElement('html','</div>');
			//show server type end

			//show server host start
			if((isset($this->current->extendserver) && $this->current->extendserver != 0) || !$valid){
				$mform->addElement('html','<div id="chat_host" style="display:none;" >');
			}else{
				$mform->addElement('html','<div id="chat_host" >');
			}
			$mform->addElement('text', 'server_host', get_string('server_host', 'flashchat'), array('size'=>'64'));
			$mform->setType('server_host', PARAM_TEXT);
			$mform->addElement('static', '','','Default:'.$_SERVER['SERVER_NAME']);
			$mform->addElement('html','</div>');
			//show server host end			
			//show server port start
			if((isset($this->current->extendserver) && $this->current->extendserver != 0) || !$valid){
				$mform->addElement('html','<div id="chat_port" style="display:none;" >');
			}else{
				$mform->addElement('html','<div id="chat_port" >');
			}
			$mform->addElement('text', 'server_port', get_string('server_port', 'flashchat'), array('size'=>'5', 'id'=>'fc_server_port'));
			$mform->setType('server_port', PARAM_TEXT);
			$mform->addElement('static', '','','Default: <span id="default_server_port">'.($this->current->servertype == 1 ? 51212 : 51127).'</span>');
			$mform->addElement('html','</div>');
			//show server port end			
			//show server http_port start
			if((isset($this->current->extendserver) && $this->current->extendserver != 0) || !$valid){
				$mform->addElement('html','<div id="http_port" style="display:none;" >');
			}else{
				$mform->addElement('html','<div id="http_port" >');
			}
			$mform->addElement('text', 'server_port_h', get_string('server_port_h', 'flashchat'), array('size'=>'5', 'id'=>'fc_server_port_h'));
			$mform->setType('server_port_h', PARAM_TEXT);
			$mform->addElement('static', '','','Default: <span id="default_http_port">'.($this->current->servertype == 1 ? 31212 : 35555).'</span>');
			$mform->addElement('html','</div>');
			//show server http_port end	
			
			//show client location start
			if(isset($this->current->extendserver) && $this->current->extendserver == 2 ){
				$mform->addElement('html','<div id="client_location" style="display:none;" >');
			}else{
				$mform->addElement('html','<div id="client_location" >');
			}
			$mform->addElement('text', 'client_loc', get_string('client_location', 'flashchat'), array('size'=>'64','id'=>'fc_client_loc'));
			$mform->setType('client_loc', PARAM_TEXT);
			$mform->addElement('static', '','','<span id="client_loc0" '.($this->current->extendserver != 0 ? 'style="display:none;"' : '').'>Example: http://'.$_SERVER['SERVER_NAME'].
				':'.($this->current->servertype == 0 ? 35555 : 31212).'/</span><span id="client_loc1" '.($this->current->extendserver != 1 ? 'style="display:none;"' : '').'>Example: http://hostxxx.123flashchat.com/group_name/</span></div>');
			//show client location end
			
			//show client type start
			if((isset($this->current->extendserver) && $this->current->extendserver == 2) || ($this->current->servertype == 1 && $this->current->extendserver == 0)){
				$mform->addElement('html','<div id="client_type" style="display:none;" >');
			}else{
				$mform->addElement('html','<div id="client_type" >');
			}
			$mform->addElement('radio', 'clienttype', get_string('chat_client_type', 'flashchat'), get_string('html_chat', 'flashchat'),0);
			$mform->addElement('radio', 'clienttype', '', get_string('flash_chat', 'flashchat'),1);
			$mform->setType('clienttype', PARAM_INT);			
			$mform->addElement('html','</div>');
			//show client type end
			
			//show room name start
			if(isset($this->current->extendserver) && $this->current->extendserver == 2 ){
				$mform->addElement('html','<div id="room_name" >');
			}else{
				$mform->addElement('html','<div id="room_name" style="display:none;" >');
			}
			$mform->addElement('text', 'room', get_string('room_name', 'flashchat'), array('size'=>'20'));
			$mform->setType('room', PARAM_TEXT);
			$mform->addElement('html','</div>');
			//show room name end
			
			//show room list start
			if(isset($this->current->extendserver) && $this->current->extendserver != 2 ){
				$mform->addElement('html','<div id="room_list" >');
			}else{
				$mform->addElement('html','<div id="room_list" style="display:none;" >');
			}
			$mform->addElement('checkbox', 'room_list', get_string('room_list', 'flashchat'), '',1);
			$mform->setType('room_list', PARAM_INT);
			$mform->addElement('html','</div>');
			//show room list end
			
			//show user list start
			$mform->addElement('checkbox', 'user_list', get_string('user_list', 'flashchat'), '',1);
			$mform->setType('user_list', PARAM_INT);
			//show user list end

			//advanced sttings
			$mform->addElement('header', 'flashchatfieldset', get_string('advanced_settings', 'flashchat'));	
			
			//show fullscreen or custom start
			$mform->addElement('radio', 'fullscreen', get_string('chatclientsize', 'flashchat'), get_string('customsize', 'flashchat'),0, array('onclick'=>'showchatsize(1);'));
			
			$mform->addElement('html','<span id="chatsize" ' . ($this->current->fullscreen == 1 ? 'style="display:none;"' : '') . ' >');
			$mform->addElement('text', 'client_width', get_string('width', 'flashchat'), 'maxlength="5" size="5"');
			$mform->setType('client_width', PARAM_INT);
			$mform->addElement('text', 'client_height', get_string('height', 'flashchat'), 'maxlength="5" size="5"');
			$mform->setType('client_height', PARAM_INT);
			$mform->addElement('html','</span>');
			
			$mform->addElement('radio', 'fullscreen', '', get_string('fullscreen', 'flashchat'),1, array('onclick'=>'showchatsize(0);'));
			$mform->setType('fullscreen', PARAM_INT);
			//show fullscreen or custom end

			
			//show client lang start
			$mform->addElement('html','<div id="u_al" ' . ($this->current->extendserver == 2 ? 'style="display:none;"' : '') . ' >');
			$mform->addElement('static', '',get_string('language', 'flashchat'),'Note: You can set the language in 123FlashChat Admin Panel -&gt; Client Settings -&gt; Languages');
			$mform->addElement('html','</div>');
			
			$mform->addElement('html','<div id="set_lang" ' . ($this->current->extendserver != 2 ? 'style="display:none;"' : '') . ' >');
			$mform->addElement('select', 'client_lang', get_string('language', 'flashchat'), 
				array(
					'auto'=>'Auto detect',
					'en'=>'English',
					'zh-CN'=>'GB Chinese',
					'zh-TW'=>'Big5 Chinese',
					'fr'=>'French',
					'it'=>'Italian',
					'de'=>'German',
					'nl'=>'Dutch',
					'hu'=>'Hungarian',
					'es'=>'Spanish',
					'hr'=>'Croatian',
					'tr'=>'Turkish',
					'ar'=>'Arabic',
					'pt'=>'Portuguese',
					'ru'=>'Russian',
					'ko'=>'Korean',
					'serbian'=>'Serbian',
					'no'=>'Norwegian',
					'ja'=>'Japanese'
				));	
			$mform->setType('client_lang', PARAM_TEXT);
			$mform->addElement('html','</div>');
			//show client lang end
			
			//show client skin start
			$mform->addElement('html','<div id="u_as" ' . ($this->current->extendserver == 2 ? 'style="display:none;"' : '') . ' >');
			$mform->addElement('static', '',get_string('skin', 'flashchat'),'Note: You can set the skin in 123FlashChat Admin Panel -&gt; Client Settings -&gt; Skin');		
			$mform->addElement('html','</div>');
			
			$mform->addElement('html','<div id="set_skin" ' . ($this->current->extendserver != 2 ? 'style="display:none;"' : '') . ' >');
			$mform->addElement('select', 'client_skin', get_string('skin', 'flashchat'), 
				array('default'=>'Default',
					'green'=>'Green',
					'orange'=>'Orange',
					'red'=>'Red',
					'black'=>'Black',
					'beige'=>'Beige',
					'standard'=>'Standard',
					'clean'=>'Clean',
					'artistic'=>'Artistic'
				));
			$mform->setType('client_skin', PARAM_TEXT);
			$mform->addElement('html','</div>');
			//show client skin end
			
			$mform->addElement('hidden', 'server_loc',isset($this->current->extendserver)? $this->current->extendserver : '',array('id'=>'server_loc'));
			$mform->setType('server_loc', PARAM_INT);
			$mform->addElement('hidden', 'name', isset($this->current->name)? $this->current->name : '123 Flash Chat',array());
	        $mform->setType('name', PARAM_TEXT);
			
			if(!isset($this->current->extendserver)){
				$mform->addElement('html','<script>document.getElementById("id_extendserver_2").checked = true;
						document.getElementById("login_chat").style.display = "none";
						document.getElementById("room_name").style.display = "block";					
					</script>');
			}
			
			$this->standard_coursemodule_elements();
			$this->add_action_buttons();
		}
	}
	
}
?>
